diff --git a/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c b/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c
index ad2fda1caa..83b4c8f94f 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c
+++ b/usr/src/uts/common/io/cxgbe/t4nex/t4_nexus.c
@@ -1670,392 +2086,518 @@ init_driver_props(struct adapter *sc, struct driver_properties *p)
 	(void) ddi_prop_update_int_array(dev, dip, "holdoff-pkt-counter-values",
 	    (int *)p->holdoff_pktcnt, SGE_NCOUNTERS);
 
-	/*
-	 * Maximum # of tx and rx queues to use for each
-	 * 100G, 40G, 25G, 10G and 1G port.
-	 */
-	p->max_ntxq_10g = prop_lookup_int(sc, "max-ntxq-10G-port", 8);
-	(void) ddi_prop_update_int(dev, dip, "max-ntxq-10G-port",
-	    p->max_ntxq_10g);
-
-	p->max_nrxq_10g = prop_lookup_int(sc, "max-nrxq-10G-port", 8);
-	(void) ddi_prop_update_int(dev, dip, "max-nrxq-10G-port",
-	    p->max_nrxq_10g);
-
-	p->max_ntxq_1g = prop_lookup_int(sc, "max-ntxq-1G-port", 2);
-	(void) ddi_prop_update_int(dev, dip, "max-ntxq-1G-port",
-	    p->max_ntxq_1g);
-
-	p->max_nrxq_1g = prop_lookup_int(sc, "max-nrxq-1G-port", 2);
-	(void) ddi_prop_update_int(dev, dip, "max-nrxq-1G-port",
-	    p->max_nrxq_1g);
-
-	/*
-	 * Holdoff parameters for 10G and 1G ports.
-	 */
-	p->tmr_idx_10g = prop_lookup_int(sc, "holdoff-timer-idx-10G", 0);
-	(void) ddi_prop_update_int(dev, dip, "holdoff-timer-idx-10G",
-	    p->tmr_idx_10g);
-
-	p->pktc_idx_10g = prop_lookup_int(sc, "holdoff-pktc-idx-10G", 2);
-	(void) ddi_prop_update_int(dev, dip, "holdoff-pktc-idx-10G",
-	    p->pktc_idx_10g);
+	p->ethq_tmr_idx = prop_lookup_int(sc, "holdoff-timer-idx", 0);
+	p->ethq_pktc_idx = prop_lookup_int(sc, "holdoff-pktc-idx", 2);
 
-	p->tmr_idx_1g = prop_lookup_int(sc, "holdoff-timer-idx-1G", 0);
-	(void) ddi_prop_update_int(dev, dip, "holdoff-timer-idx-1G",
-	    p->tmr_idx_1g);
+	(void) ddi_prop_update_int(dev, dip, "holdoff-timer-idx",
+	    p->ethq_tmr_idx);
+	(void) ddi_prop_update_int(dev, dip, "holdoff-pktc-idx",
+	    p->ethq_pktc_idx);
 
-	p->pktc_idx_1g = prop_lookup_int(sc, "holdoff-pktc-idx-1G", 2);
-	(void) ddi_prop_update_int(dev, dip, "holdoff-pktc-idx-1G",
-	    p->pktc_idx_1g);
-
-	/*
-	 * Size (number of entries) of each tx and rx queue.
-	 */
-	i = prop_lookup_int(sc, "qsize-txq", TX_EQ_QSIZE);
-	p->qsize_txq = max(i, 128);
-	if (p->qsize_txq != i) {
+	/* The size (number of host credits) of the tx queue. */
+	val = prop_lookup_int(sc, "qsize-txq", T4_TX_DEF_QSIZE);
+	p->qsize_txq = MAX(val, 128);
+	p->qsize_txq = MIN(p->qsize_txq, T4_MAX_EQ_SIZE);
+	if (p->qsize_txq != val) {
 		cxgb_printf(dip, CE_WARN,
 		    "using %d instead of %d as the tx queue size",
-		    p->qsize_txq, i);
+		    p->qsize_txq, val);
 	}
 	(void) ddi_prop_update_int(dev, dip, "qsize-txq", p->qsize_txq);
 
-	i = prop_lookup_int(sc, "qsize-rxq", RX_IQ_QSIZE);
-	p->qsize_rxq = max(i, 128);
-	while (p->qsize_rxq & 7)
-		p->qsize_rxq--;
-	if (p->qsize_rxq != i) {
-		cxgb_printf(dip, CE_WARN,
-		    "using %d instead of %d as the rx queue size",
-		    p->qsize_rxq, i);
-	}
-	(void) ddi_prop_update_int(dev, dip, "qsize-rxq", p->qsize_rxq);
-
 	/*
-	 * Interrupt types allowed.
-	 * Bits 0, 1, 2 = INTx, MSI, MSI-X respectively.  See sys/ddi_intr.h
+	 * The size (number of entries/host credits) of the rx queue. The device
+	 * requires that all IQs be sized to a multiple of 16.
 	 */
-	p->intr_types = prop_lookup_int(sc, "interrupt-types",
-	    DDI_INTR_TYPE_MSIX | DDI_INTR_TYPE_MSI | DDI_INTR_TYPE_FIXED);
-	(void) ddi_prop_update_int(dev, dip, "interrupt-types", p->intr_types);
-
-	/*
-	 * Write combining
-	 * 0 to disable, 1 to enable
-	 */
-	p->wc = prop_lookup_int(sc, "write-combine", 1);
-	cxgb_printf(dip, CE_WARN, "write-combine: using of %d", p->wc);
-	if (p->wc != 0 && p->wc != 1) {
+	val = prop_lookup_int(sc, "qsize-rxq", T4_RX_DEF_QSIZE);
+	p->qsize_rxq = MAX(val, 128) & ~15;
+	p->qsize_rxq = MIN(p->qsize_rxq, SGE_MAX_IQ_SIZE);
+	if (p->qsize_rxq != val) {
 		cxgb_printf(dip, CE_WARN,
-		    "write-combine: using 1 instead of %d", p->wc);
-		p->wc = 1;
+		    "using %u instead of %d as the rx queue size",
+		    p->qsize_rxq, val);
 	}
-	(void) ddi_prop_update_int(dev, dip, "write-combine", p->wc);
+	(void) ddi_prop_update_int(dev, dip, "qsize-rxq", p->qsize_rxq);
+
+	p->write_combine = prop_lookup_bool(sc, "write-combine", true);
+	(void) ddi_prop_update_int(dev, dip, "write-combine",
+	    p->write_combine ? 1 : 0);
 
 	p->t4_fw_install = prop_lookup_int(sc, "t4_fw_install", 1);
 	if (p->t4_fw_install != 0 && p->t4_fw_install != 2)
 		p->t4_fw_install = 1;
 	(void) ddi_prop_update_int(dev, dip, "t4_fw_install", p->t4_fw_install);
+}
 
-	/* Multiple Rings */
-	p->multi_rings = prop_lookup_int(sc, "multi-rings", 1);
-	if (p->multi_rings != 0 && p->multi_rings != 1) {
-		cxgb_printf(dip, CE_NOTE,
-		    "multi-rings: using value 1 instead of %d", p->multi_rings);
-		p->multi_rings = 1;
-	}
-
-	(void) ddi_prop_update_int(dev, dip, "multi-rings", p->multi_rings);
+/*
+ * Permit artificial clamping of interrupts for device.
+ * Provided mainly for development and testing purposes.
+ */
+static int t4_intr_count_clamp = 0;
 
-	return (0);
-}
+/*
+ * Queue counts to allocate per-port based on device speed.
+ *
+ * These have been picked somewhat arbitrarily, and should be further
+ * scrutinized with additional testing.
+ */
+#define	T4_QCNT(speed, num)	[speed] = { speed, num, num }
+static const struct t4_queue_count {
+	t4_port_speed_t tqc_speed;
+	uint_t		tqc_rxq_count;
+	uint_t		tqc_txq_count;
+} t4_queue_counts[] = {
+	T4_QCNT(TPS_1G, 2),
+	T4_QCNT(TPS_10G, 8),
+	T4_QCNT(TPS_25G, 16),
+	T4_QCNT(TPS_40G, 24),
+	T4_QCNT(TPS_50G, 24),
+	T4_QCNT(TPS_100G, 32),
+	T4_QCNT(TPS_200G, 48),
+	T4_QCNT(TPS_400G, 64),
+};
 
 static int
-remove_extra_props(struct adapter *sc, int n10g, int n1g)
+t4_cfg_intrs_queues(struct adapter *sc)
 {
-	if (n10g == 0) {
-		(void) ddi_prop_remove(sc->dev, sc->dip, "max-ntxq-10G-port");
-		(void) ddi_prop_remove(sc->dev, sc->dip, "max-nrxq-10G-port");
-		(void) ddi_prop_remove(sc->dev, sc->dip,
-		    "holdoff-timer-idx-10G");
-		(void) ddi_prop_remove(sc->dev, sc->dip,
-		    "holdoff-pktc-idx-10G");
+	struct t4_intrs_queues *iaq = &sc->intr_queue_cfg;
+	int rc;
+
+	bzero(iaq, sizeof (*iaq));
+
+	int supported_itypes;
+	rc = ddi_intr_get_supported_types(sc->dip, &supported_itypes);
+	if (rc != DDI_SUCCESS) {
+		cxgb_printf(sc->dip, CE_WARN,
+		    "failed to determine supported interrupt types: %d", rc);
+		return (rc);
 	}
 
-	if (n1g == 0) {
-		(void) ddi_prop_remove(sc->dev, sc->dip, "max-ntxq-1G-port");
-		(void) ddi_prop_remove(sc->dev, sc->dip, "max-nrxq-1G-port");
-		(void) ddi_prop_remove(sc->dev, sc->dip,
-		    "holdoff-timer-idx-1G");
-		(void) ddi_prop_remove(sc->dev, sc->dip, "holdoff-pktc-idx-1G");
+	const int intr_types[] = {
+		DDI_INTR_TYPE_MSIX, DDI_INTR_TYPE_MSI, DDI_INTR_TYPE_FIXED,
+	};
+	const char *intr_str[] = { "MSI-X", "MSI", "Fixed" };
+	int itype = -1;
+
+	for (uint_t i = 0; i < ARRAY_SIZE(intr_types); i++) {
+		itype = intr_types[i];
+		if ((itype & supported_itypes) == 0) {
+			continue;
+		}
+
+		rc = ddi_intr_get_navail(sc->dip, itype, &iaq->intr_avail);
+		if (rc != DDI_SUCCESS || iaq->intr_avail < 0) {
+			cxgb_printf(sc->dip, CE_WARN, "failed to query "
+			    "available interrupts for type %s: %d", intr_str[i],
+			    rc);
+			continue;
+		}
+
+		/*
+		 * The device error and FWQ interrupts are hard-coded to indexes
+		 * 0 and 1, respectively.  We require at least two interrupts be
+		 * available for MSI(-X) in order to cover both of those cases.
+		 */
+		if (iaq->intr_avail >= 2 ||
+		    (iaq->intr_avail == 1 && itype == DDI_INTR_TYPE_FIXED)) {
+			break;
+		}
 	}
 
-	return (0);
-}
+	if (iaq->intr_avail == 0) {
+		cxgb_printf(sc->dip, CE_WARN, "failed to get any interrupts "
+		    "after querying all types");
+		return (rc);
+	}
 
-static int
-cfg_itype_and_nqueues(struct adapter *sc, int n10g, int n1g,
-    struct intrs_and_queues *iaq)
-{
-	struct driver_properties *p = &sc->props;
-	int rc, itype, itypes, navail, nc, n;
-	int pfres_rxq, pfres_txq, pfresq;
+	ASSERT3S(iaq->intr_avail, >, 0);
+	iaq->intr_type = itype;
+	iaq->intr_count = iaq->intr_avail;
 
-	bzero(iaq, sizeof (*iaq));
-	nc = ncpus;	/* our snapshot of the number of CPUs */
-	iaq->ntxq10g = min(nc, p->max_ntxq_10g);
-	iaq->ntxq1g = min(nc, p->max_ntxq_1g);
-	iaq->nrxq10g = min(nc, p->max_nrxq_10g);
-	iaq->nrxq1g = min(nc, p->max_nrxq_1g);
+	/* Permit artificial clamping of consumed interrupts. */
+	if (t4_intr_count_clamp > 1) {
+		iaq->intr_count = MIN(iaq->intr_avail, t4_intr_count_clamp);
+	}
+
+	const uint_t port_count = sc->params.nports;
+
+	iaq->intr_per_port = 0;
+	/* One IQ for the FWQ */
+	iaq->num_iqs = 1;
 
-	pfres_rxq = iaq->nrxq10g * n10g + iaq->nrxq1g * n1g;
-	pfres_txq = iaq->ntxq10g * n10g + iaq->ntxq1g * n1g;
+	if (iaq->intr_count == 1) {
+		iaq->intr_plan = TIP_SINGLE;
+	} else if (iaq->intr_count == 2 || iaq->intr_count < (port_count + 2)) {
+		iaq->intr_plan = TIP_ERR_QUEUES;
+	} else {
+		/*
+		 * We know the interrupt count is at least equal to
+		 * port_count+2, and thus we should always have at least
+		 * one event interrupt per port.
+		 */
+		VERIFY(iaq->intr_count >= (port_count + 2));
+		iaq->intr_plan = TIP_PER_PORT;
+		iaq->intr_per_port = (iaq->intr_count - 2) / port_count;
+		VERIFY3U(iaq->intr_per_port, >, 0);
+		iaq->num_iqs += iaq->intr_per_port * port_count;
+	}
 
+	const struct pf_resources *pfres = &sc->params.pfres;
+	if (pfres->niqflint <= 1) {
+		/* We cannot achieve much with a single IQ */
+		cxgb_printf(sc->dip, CE_WARN,
+		    "inadequate IQ resources available");
+		return (DDI_FAILURE);
+	}
+
+	const uint_t port_iqs = pfres->niqflint - iaq->num_iqs;
 	/*
-	 * If current configuration of max number of Rxqs and Txqs exceed
-	 * the max available for all the ports under this PF, then shrink
-	 * the queues to max available. Reduce them in a way that each
-	 * port under this PF has equally distributed number of queues.
-	 * Must guarantee at least 1 queue for each port for both NIC
-	 * and Offload queues.
-	 *
-	 * neq - fixed max number of Egress queues on Tx path and Free List
-	 * queues that hold Rx payload data on Rx path. Half are reserved
-	 * for Egress queues and the other half for Free List queues.
-	 * Hence, the division by 2.
+	 * Every RX queue needs an IQ capable of interrupts (for the receive
+	 * notifications) as well as an EQ (for posting the freelist entries to
+	 * the device.  Half of the total EQs are left for TXQs.
+	 */
+	const uint_t max_rxq = MIN(port_iqs, pfres->neq / 2);
+
+	/* Every TX queue needs an ethernet-capable EQ. */
+	const uint_t max_txq = MIN(pfres->nethctrl, pfres->neq / 2);
+
+	if ((max_rxq / port_count) == 0) {
+		cxgb_printf(sc->dip, CE_WARN,
+		    "inadequate RX queue resources available");
+		return (DDI_FAILURE);
+	} else if ((max_txq / port_count) == 0) {
+		cxgb_printf(sc->dip, CE_WARN,
+		    "inadequate TX queue resources available");
+		return (DDI_FAILURE);
+	}
+
+	/* Clamp max queue counts to number of CPUs */
+	iaq->port_max_rxq = MIN(max_rxq, ncpus);
+	iaq->port_max_txq = MIN(max_txq, ncpus);
+
+	VERIFY(iaq->intr_count > 0);
+	VERIFY(iaq->port_max_rxq != 0);
+	VERIFY(iaq->port_max_txq != 0);
+	VERIFY(iaq->num_iqs != 0);
+
+	/*
+	 * Determine per-port queue counts based on maximum port speed.
 	 *
-	 * niqflint - max number of Ingress queues with interrupts on Rx
-	 * path to receive completions that indicate Rx payload has been
-	 * posted in its associated Free List queue. Also handles Tx
-	 * completions for packets successfully transmitted on Tx path.
+	 * This is a bit unfortunate, since there does not seem to be a way to
+	 * query the maximum possible speed for a port independent of any
+	 * installed transceiver.  If a transceiver of lesser speed capability
+	 * is installed in a port, that port will clamp its own reported
+	 * capabilities to those of the transceiver.
 	 *
-	 * nethctrl - max number of Egress queues only for Tx path. This
-	 * number is usually half of neq. However, if it became less than
-	 * neq due to lack of resources based on firmware configuration,
-	 * then take the lower value.
+	 * Our compromise is to size queue allocations based on the fastest port
+	 * we can find.  This will be less than ideal for adapters with
+	 * heterogeneous port configurations or systems where transceivers of
+	 * differing speed capabilities are swapped in after the driver
+	 * initializes the adapter(s).
 	 */
-	const uint_t max_rxq =
-	    MIN(sc->params.pfres.neq / 2, sc->params.pfres.niqflint);
-	while (pfres_rxq > max_rxq) {
-		pfresq = pfres_rxq;
-
-		if (iaq->nrxq10g > 1) {
-			iaq->nrxq10g--;
-			pfres_rxq -= n10g;
-		}
+	t4_port_speed_t max_speed = TPS_1G;
+	for (uint_t i = 0; i < port_count; i++) {
+		max_speed = MAX(max_speed, t4_port_speed(sc->port[i]));
+	}
+	ASSERT(max_speed < ARRAY_SIZE(t4_queue_counts));
+	const struct t4_queue_count *qc = &t4_queue_counts[max_speed];
 
-		if (iaq->nrxq1g > 1) {
-			iaq->nrxq1g--;
-			pfres_rxq -= n1g;
-		}
+	uint_t rxq_idx = 0, txq_idx = 0;
+	for (uint_t i = 0; i < port_count; i++) {
+		struct port_info *pi = sc->port[i];
 
-		/* Break if nothing changed */
-		if (pfresq == pfres_rxq)
-			break;
+		/* Clamp to per-port maximums */
+		pi->rxq_count = MIN(qc->tqc_rxq_count, iaq->port_max_rxq);
+		pi->txq_count = MIN(qc->tqc_txq_count, iaq->port_max_txq);
+
+		pi->rxq_start = rxq_idx;
+		pi->txq_start = txq_idx;
+		rxq_idx += pi->rxq_count;
+		txq_idx += pi->txq_count;
 	}
 
-	const uint_t max_txq =
-	    MIN(sc->params.pfres.neq / 2, sc->params.pfres.nethctrl);
-	while (pfres_txq > max_txq) {
-		pfresq = pfres_txq;
+	struct sge_info *sge = &sc->sge;
+	sge->rxq_count = rxq_idx;
+	sge->txq_count = txq_idx;
 
-		if (iaq->ntxq10g > 1) {
-			iaq->ntxq10g--;
-			pfres_txq -= n10g;
-		}
+	cxgb_printf(sc->dip, CE_NOTE, "(%u rxq, %u txq total) %d %s.",
+	    rxq_idx, txq_idx, iaq->intr_count,
+	    iaq->intr_type == DDI_INTR_TYPE_MSIX ? "MSI-X interrupts" :
+	    iaq->intr_type == DDI_INTR_TYPE_MSI ? "MSI interrupts" :
+	    "fixed interrupt");
 
-		if (iaq->ntxq1g > 1) {
-			iaq->ntxq1g--;
-			pfres_txq -= n1g;
-		}
+	return (DDI_SUCCESS);
+}
 
-		/* Break if nothing changed */
-		if (pfresq == pfres_txq)
-			break;
+static int
+t4_setup_port_intrs(struct adapter *sc, int *handlers)
+{
+	int rc = 0;
+	const struct t4_intrs_queues *iaq = &sc->intr_queue_cfg;
+
+	for (uint_t i = 0; i < sc->params.nports; i++) {
+		struct port_info *port = sc->port[i];
+
+		port->intr_iqs = kmem_zalloc(iaq->intr_per_port *
+		    sizeof (t4_sge_iq_t), KM_SLEEP);
+
+		for (uint_t j = 0; j < iaq->intr_per_port; j++) {
+			uint_t intr_idx = 2 + (i * iaq->intr_per_port) + j;
+			VERIFY3S(intr_idx, <, iaq->intr_count);
+			ddi_intr_handle_t ihdl = sc->intr_handle[intr_idx];
+			rc = ddi_intr_add_handler(ihdl, t4_intr_port_queue,
+			    &port->intr_iqs[j], NULL);
+			if (rc != DDI_SUCCESS) {
+				/*
+				 * Previously installed handlers are cleaned up
+				 * by the parent function.
+				 */
+				cxgb_printf(sc->dip, CE_WARN, "failed to add "
+				    "interrupt handler %u for type: %d plan: "
+				    "%d: %d", intr_idx, iaq->intr_type,
+				    iaq->intr_plan, rc);
+				return (rc);
+			}
+			*handlers += 1;
+		}
 	}
 
-	rc = ddi_intr_get_supported_types(sc->dip, &itypes);
+	return (DDI_SUCCESS);
+}
+
+static int
+t4_setup_intrs(struct adapter *sc)
+{
+	const struct t4_intrs_queues *iaq = &sc->intr_queue_cfg;
+	const int intr_count = iaq->intr_count;
+	const int intr_type = iaq->intr_type;
+	int allocated = 0;
+	int handlers = 0;
+
+	int rc = ddi_intr_alloc(sc->dip, sc->intr_handle, intr_type, 0,
+	    intr_count, &allocated, DDI_INTR_ALLOC_STRICT);
 	if (rc != DDI_SUCCESS) {
 		cxgb_printf(sc->dip, CE_WARN,
-		    "failed to determine supported interrupt types: %d", rc);
-		return (rc);
+		    "failed to allocate %d interrupt(s) of type %d: %d, %d",
+		    intr_count, intr_type, rc, allocated);
+		goto fail;
 	}
 
-	for (itype = DDI_INTR_TYPE_MSIX; itype; itype >>= 1) {
-		ASSERT(itype == DDI_INTR_TYPE_MSIX ||
-		    itype == DDI_INTR_TYPE_MSI ||
-		    itype == DDI_INTR_TYPE_FIXED);
+	VERIFY3U(intr_count, ==, allocated); /* allocation was STRICT */
 
-		if ((itype & itypes & p->intr_types) == 0)
-			continue;	/* not supported or not allowed */
+	rc = ddi_intr_get_cap(sc->intr_handle[0], &sc->intr_cap);
+	if (rc != DDI_SUCCESS) {
+		cxgb_printf(sc->dip, CE_WARN, "failed to get interrupt "
+		    "capabilities for type %d: %d", intr_type, rc);
+		goto fail;
+	}
 
-		navail = 0;
-		rc = ddi_intr_get_navail(sc->dip, itype, &navail);
-		if (rc != DDI_SUCCESS || navail == 0) {
-			cxgb_printf(sc->dip, CE_WARN,
-			    "failed to get # of interrupts for type %d: %d",
-			    itype, rc);
-			continue;	/* carry on */
+	rc = ddi_intr_get_pri(sc->intr_handle[0], &sc->intr_pri);
+	if (rc != DDI_SUCCESS) {
+		cxgb_printf(sc->dip, CE_WARN, "failed to get interrupt "
+		    "priority for type %d: %d", intr_type, rc);
+		goto fail;
+	}
+
+	switch (iaq->intr_plan) {
+	case TIP_SINGLE:
+		ASSERT3U(intr_count, ==, 1);
+		rc = ddi_intr_add_handler(sc->intr_handle[0], t4_intr_all, sc,
+		    NULL);
+		if (rc != DDI_SUCCESS) {
+			cxgb_printf(sc->dip, CE_WARN, "failed to add interrupt "
+			    "handler %u for type: %d plan: %d: %d", handlers,
+			    intr_type, iaq->intr_plan, rc);
+			goto fail;
 		}
+		handlers++;
+		break;
 
-		iaq->intr_type = itype;
-		if (navail == 0)
-			continue;
+	case TIP_ERR_QUEUES:
+		VERIFY3U(intr_count, ==, 2);
+		rc = ddi_intr_add_handler(sc->intr_handle[0], t4_intr_err, sc,
+		    NULL);
+		if (rc != DDI_SUCCESS) {
+			cxgb_printf(sc->dip, CE_WARN, "failed to add interrupt "
+			    "handler %u for type: %d plan: %d: %d", handlers,
+			    intr_type, iaq->intr_plan, rc);
+			goto fail;
+		}
+		handlers++;
 
-		/*
-		 * Best option: an interrupt vector for errors, one for the
-		 * firmware event queue, and one each for each rxq (NIC as well
-		 * as offload).
-		 */
-		iaq->nirq = T4_EXTRA_INTR;
-		iaq->nirq += n10g * iaq->nrxq10g;
-		iaq->nirq += n1g * iaq->nrxq1g;
-
-		if (iaq->nirq <= navail &&
-		    (itype != DDI_INTR_TYPE_MSI || ISP2(iaq->nirq))) {
-			iaq->intr_fwd = 0;
-			goto allocate;
+		rc = ddi_intr_add_handler(sc->intr_handle[1], t4_intr_fwq, sc,
+		    NULL);
+		if (rc != DDI_SUCCESS) {
+			cxgb_printf(sc->dip, CE_WARN, "failed to add interrupt "
+			    "handler %u for type: %d plan: %d: %d", handlers,
+			    intr_type, iaq->intr_plan, rc);
+			goto fail;
 		}
+		handlers++;
+		break;
 
-		/*
-		 * Second best option: an interrupt vector for errors, one for
-		 * the firmware event queue, and one each for either NIC or
-		 * offload rxq's.
-		 */
-		iaq->nirq = T4_EXTRA_INTR;
-		iaq->nirq += n10g * iaq->nrxq10g;
-		iaq->nirq += n1g * iaq->nrxq1g;
-		if (iaq->nirq <= navail &&
-		    (itype != DDI_INTR_TYPE_MSI || ISP2(iaq->nirq))) {
-			iaq->intr_fwd = 1;
-			goto allocate;
+	case TIP_PER_PORT:
+		VERIFY3U(intr_count, >=, 2 + sc->params.nports);
+		rc = ddi_intr_add_handler(sc->intr_handle[0], t4_intr_err, sc,
+		    NULL);
+		if (rc != DDI_SUCCESS) {
+			cxgb_printf(sc->dip, CE_WARN, "failed to add interrupt "
+			    "handler %u for type: %d plan: %d: %d", handlers,
+			    intr_type, iaq->intr_plan, rc);
+			goto fail;
 		}
+		handlers++;
 
-		/*
-		 * Next best option: an interrupt vector for errors, one for the
-		 * firmware event queue, and at least one per port.  At this
-		 * point we know we'll have to downsize nrxq or nofldrxq to fit
-		 * what's available to us.
-		 */
-		iaq->nirq = T4_EXTRA_INTR;
-		iaq->nirq += n10g + n1g;
-		if (iaq->nirq <= navail) {
-			int leftover = navail - iaq->nirq;
-
-			if (n10g > 0) {
-				int target = iaq->nrxq10g;
-
-				n = 1;
-				while (n < target && leftover >= n10g) {
-					leftover -= n10g;
-					iaq->nirq += n10g;
-					n++;
-				}
-				iaq->nrxq10g = min(n, iaq->nrxq10g);
-			}
+		rc =  ddi_intr_add_handler(sc->intr_handle[1], t4_intr_fwq, sc,
+		    NULL);
+		if (rc != DDI_SUCCESS) {
+			cxgb_printf(sc->dip, CE_WARN, "failed to add interrupt "
+			    "handler %u for type: %d plan: %d: %d", handlers,
+			    intr_type, iaq->intr_plan, rc);
+			goto fail;
+		}
+		handlers++;
 
-			if (n1g > 0) {
-				int target = iaq->nrxq1g;
+		rc = t4_setup_port_intrs(sc, &handlers);
 
-				n = 1;
-				while (n < target && leftover >= n1g) {
-					leftover -= n1g;
-					iaq->nirq += n1g;
-					n++;
-				}
-				iaq->nrxq1g = min(n, iaq->nrxq1g);
-			}
+		if (rc != DDI_SUCCESS) {
+			goto fail;
+		}
 
+		break;
+	}
+
+	return (DDI_SUCCESS);
+
+fail:
+	for (int i = 0; i < handlers; i++) {
+		rc = ddi_intr_remove_handler(sc->intr_handle[i]);
+		if (rc != DDI_SUCCESS) {
 			/*
-			 * We have arrived at a minimum value required to enable
-			 * per queue irq(either NIC or offload). Thus for non-
-			 * offload case, we will get a vector per queue, while
-			 * offload case, we will get a vector per offload/NIC q.
-			 * Hence enable Interrupt forwarding only for offload
-			 * case.
+			 * We tried our best, the only thing left is to log the
+			 * failure and move on.
 			 */
-			if (itype != DDI_INTR_TYPE_MSI) {
-				goto allocate;
-			}
+			cxgb_printf(sc->dip, CE_WARN, "failed to remove "
+			    "interrupt handler %d for type: %d plan: %d: %d", i,
+			    intr_type, iaq->intr_plan, rc);
 		}
+	}
 
-		/*
-		 * Least desirable option: one interrupt vector for everything.
-		 */
-		iaq->nirq = iaq->nrxq10g = iaq->nrxq1g = 1;
-		iaq->intr_fwd = 1;
-
-allocate:
-		return (0);
+	for (int i = 0; i < allocated; i++) {
+		rc = ddi_intr_free(sc->intr_handle[i]);
+		if (rc != DDI_SUCCESS) {
+			cxgb_printf(sc->dip, CE_WARN, "failed to free "
+			    "interrupt %d for type: %d plan: %d: %d", i,
+			    intr_type, iaq->intr_plan, rc);
+		}
 	}
 
-	cxgb_printf(sc->dip, CE_WARN,
-	    "failed to find a usable interrupt type.  supported=%d, allowed=%d",
-	    itypes, p->intr_types);
 	return (DDI_FAILURE);
 }
 
 static int
-add_child_node(struct adapter *sc, int idx)
+t4_add_child_node(struct adapter *sc, uint_t idx)
 {
-	int rc;
-	struct port_info *pi;
 
-	if (idx < 0 || idx >= sc->params.nports)
+	if (idx >= sc->params.nports)
 		return (EINVAL);
 
-	pi = sc->port[idx];
-	if (pi == NULL)
-		return (ENODEV);	/* t4_port_init failed earlier */
+	struct port_info *pi = sc->port[idx];
+	if (pi == NULL) {
+		/* t4_port_init failed earlier */
+		return (ENODEV);
+	}
 
 	PORT_LOCK(pi);
 	if (pi->dip != NULL) {
-		rc = 0;		/* EEXIST really, but then bus_config fails */
-		goto done;
+		PORT_UNLOCK(pi);
+		/* EEXIST really, but then bus_config fails */
+		return (0);
 	}
 
-	rc = ndi_devi_alloc(sc->dip, T4_PORT_NAME, DEVI_SID_NODEID, &pi->dip);
+	const int rc =
+	    ndi_devi_alloc(sc->dip, T4_PORT_NAME, DEVI_SID_NODEID, &pi->dip);
 	if (rc != DDI_SUCCESS || pi->dip == NULL) {
-		rc = ENOMEM;
-		goto done;
+		PORT_UNLOCK(pi);
+		return (ENOMEM);
 	}
 
 	(void) ddi_set_parent_data(pi->dip, pi);
 	(void) ndi_devi_bind_driver(pi->dip, 0);
-	rc = 0;
-done:
+
 	PORT_UNLOCK(pi);
-	return (rc);
+	return (0);
 }
 
 static int
-remove_child_node(struct adapter *sc, int idx)
+t4_remove_child_node(struct adapter *sc, uint_t idx)
 {
-	int rc;
-	struct port_info *pi;
-
-	if (idx < 0 || idx >= sc->params.nports)
+	if (idx >= sc->params.nports)
 		return (EINVAL);
 
-	pi = sc->port[idx];
+	struct port_info *pi = sc->port[idx];
 	if (pi == NULL)
 		return (ENODEV);
 
 	PORT_LOCK(pi);
 	if (pi->dip == NULL) {
-		rc = ENODEV;
-		goto done;
+		PORT_UNLOCK(pi);
+		return (ENODEV);
 	}
 
-	rc = ndi_devi_free(pi->dip);
+	const int rc = ndi_devi_free(pi->dip);
 	if (rc == 0)
 		pi->dip = NULL;
-done:
+
 	PORT_UNLOCK(pi);
 	return (rc);
 }
 
+struct t4_port_speed_def {
+	uint32_t	tpsd_cap;
+	t4_port_speed_t	tpsd_speed;
+	const char	*tpsd_name;
+};
+#define	T4_PORT_SPEED_DEF(speed)			\
+{							\
+	.tpsd_cap = FW_PORT_CAP32_SPEED_ ## speed,	\
+	.tpsd_speed = TPS_ ## speed,			\
+	.tpsd_name = #speed,				\
+}
+
+static const struct t4_port_speed_def t4_port_speeds[] = {
+	T4_PORT_SPEED_DEF(400G),
+	T4_PORT_SPEED_DEF(200G),
+	T4_PORT_SPEED_DEF(100G),
+	T4_PORT_SPEED_DEF(50G),
+	T4_PORT_SPEED_DEF(40G),
+	T4_PORT_SPEED_DEF(25G),
+	T4_PORT_SPEED_DEF(10G),
+	T4_PORT_SPEED_DEF(1G),
+};
+
+/*
+ * Get maximum advertised speed of this port.
+ *
+ * This is, unfortunately, impacted by the installed transceiver at the time of
+ * query.
+ */
+static t4_port_speed_t
+t4_port_speed(const struct port_info *pi)
+{
+	ASSERT(pi != NULL);
+
+	const uint32_t pcap = pi->link_cfg.pcaps;
+	for (uint_t i = 0; i < ARRAY_SIZE(t4_port_speeds); i++) {
+		if (t4_port_speeds[i].tpsd_cap & pcap) {
+			return (t4_port_speeds[i].tpsd_speed);
+		}
+	}
+
+	/* Fall back to 1G for unknown speeds */
+	return (TPS_1G);
+}
+
 static const char *
 t4_port_speed_name(const struct port_info *pi)
 {
@@ -2063,28 +2605,27 @@ t4_port_speed_name(const struct port_info *pi)
 		return ("-");
 	}
 
-	const uint32_t pcaps = pi->link_cfg.pcaps;
-	if (pcaps & FW_PORT_CAP32_SPEED_100G) {
-		return ("100G");
-	} else if (pcaps & FW_PORT_CAP32_SPEED_50G) {
-		return ("50G");
-	} else if (pcaps & FW_PORT_CAP32_SPEED_40G) {
-		return ("40G");
-	} else if (pcaps & FW_PORT_CAP32_SPEED_25G) {
-		return ("25G");
-	} else if (pcaps & FW_PORT_CAP32_SPEED_10G) {
-		return ("10G");
-	} else {
-		return ("1G");
+	const uint32_t pcap = pi->link_cfg.pcaps;
+	for (uint_t i = 0; i < ARRAY_SIZE(t4_port_speeds); i++) {
+		if (t4_port_speeds[i].tpsd_cap & pcap) {
+			return (t4_port_speeds[i].tpsd_name);
+		}
 	}
+
+	return ("-");
 }
 
-#define	KS_UINIT(x)	kstat_named_init(&kstatp->x, #x, KSTAT_DATA_ULONG)
-#define	KS_CINIT(x)	kstat_named_init(&kstatp->x, #x, KSTAT_DATA_CHAR)
-#define	KS_U64INIT(x)	kstat_named_init(&kstatp->x, #x, KSTAT_DATA_UINT64)
-#define	KS_U_SET(x, y)	kstatp->x.value.ul = (y)
-#define	KS_C_SET(x, ...)	\
-			(void) snprintf(kstatp->x.value.c, 16,  __VA_ARGS__)
+#define	KS_INIT_U64(kstatp,  n)	\
+	kstat_named_init(&kstatp->n, #n, KSTAT_DATA_UINT64)
+#define	KS_INIT_CHAR(kstatp, n)	\
+	kstat_named_init(&kstatp->n, #n, KSTAT_DATA_CHAR)
+#define	KS_INIT_STR(kstatp, n)	\
+	kstat_named_init(&kstatp->n, #n, KSTAT_DATA_STRING)
+#define	KS_SET_U64(kstatp, n, v)	kstatp->n.value.ul = (v)
+#define	KS_SET_CHAR(kstatp, n, ...)	\
+	(void) snprintf(kstatp->n.value.c, 16,  __VA_ARGS__)
+#define	KS_SET_STR(kstatp, n, v)	\
+	kstat_named_setstr(&kstatp->n, v)
 
 /*
  * t4nex:X:config
@@ -2097,80 +2638,57 @@ struct t4_kstats {
 	kstat_named_t serial_number;
 	kstat_named_t ec_level;
 	kstat_named_t id;
-	kstat_named_t bus_type;
-	kstat_named_t bus_width;
-	kstat_named_t bus_speed;
 	kstat_named_t core_clock;
 	kstat_named_t port_cnt;
 	kstat_named_t port_type;
-	kstat_named_t pci_vendor_id;
-	kstat_named_t pci_device_id;
 };
+
 static kstat_t *
-setup_kstats(struct adapter *sc)
+t4_setup_kstats(struct adapter *sc)
 {
-	kstat_t *ksp;
-	struct t4_kstats *kstatp;
-	int ndata;
-	struct pci_params *p = &sc->params.pci;
-	struct vpd_params *v = &sc->params.vpd;
-	uint16_t pci_vendor, pci_device;
-
-	ndata = sizeof (struct t4_kstats) / sizeof (kstat_named_t);
-
-	ksp = kstat_create(T4_NEXUS_NAME, ddi_get_instance(sc->dip), "config",
-	    "nexus", KSTAT_TYPE_NAMED, ndata, 0);
+	const ulong_t ndata = sizeof (struct t4_kstats) /
+	    sizeof (kstat_named_t);
+	kstat_t *ksp = kstat_create(T4_NEXUS_NAME, ddi_get_instance(sc->dip),
+	    "config", "nexus", KSTAT_TYPE_NAMED, ndata, 0);
 	if (ksp == NULL) {
 		cxgb_printf(sc->dip, CE_WARN, "failed to initialize kstats.");
 		return (NULL);
 	}
 
-	kstatp = (struct t4_kstats *)ksp->ks_data;
-
-	KS_UINIT(chip_ver);
-	KS_CINIT(fw_vers);
-	KS_CINIT(tp_vers);
-	KS_CINIT(driver_version);
-	KS_CINIT(serial_number);
-	KS_CINIT(ec_level);
-	KS_CINIT(id);
-	KS_CINIT(bus_type);
-	KS_CINIT(bus_width);
-	KS_CINIT(bus_speed);
-	KS_UINIT(core_clock);
-	KS_UINIT(port_cnt);
-	KS_CINIT(port_type);
-	KS_CINIT(pci_vendor_id);
-	KS_CINIT(pci_device_id);
-
-	KS_U_SET(chip_ver, sc->params.chip);
-	KS_C_SET(fw_vers, "%d.%d.%d.%d",
+	struct t4_kstats *kstatp = (struct t4_kstats *)ksp->ks_data;
+
+	KS_INIT_U64(kstatp, chip_ver);
+	KS_INIT_CHAR(kstatp, fw_vers);
+	KS_INIT_CHAR(kstatp, tp_vers);
+	KS_INIT_CHAR(kstatp, driver_version);
+	KS_INIT_STR(kstatp, serial_number);
+	KS_INIT_STR(kstatp, ec_level);
+	KS_INIT_STR(kstatp, id);
+	KS_INIT_U64(kstatp, core_clock);
+	KS_INIT_U64(kstatp, port_cnt);
+	KS_INIT_CHAR(kstatp, port_type);
+
+	KS_SET_U64(kstatp, chip_ver, sc->params.chip);
+	KS_SET_CHAR(kstatp, fw_vers, "%d.%d.%d.%d",
 	    G_FW_HDR_FW_VER_MAJOR(sc->params.fw_vers),
 	    G_FW_HDR_FW_VER_MINOR(sc->params.fw_vers),
 	    G_FW_HDR_FW_VER_MICRO(sc->params.fw_vers),
 	    G_FW_HDR_FW_VER_BUILD(sc->params.fw_vers));
-	KS_C_SET(tp_vers, "%d.%d.%d.%d",
+	KS_SET_CHAR(kstatp, tp_vers, "%d.%d.%d.%d",
 	    G_FW_HDR_FW_VER_MAJOR(sc->params.tp_vers),
 	    G_FW_HDR_FW_VER_MINOR(sc->params.tp_vers),
 	    G_FW_HDR_FW_VER_MICRO(sc->params.tp_vers),
 	    G_FW_HDR_FW_VER_BUILD(sc->params.tp_vers));
-	KS_C_SET(driver_version, DRV_VERSION);
-	KS_C_SET(serial_number, "%s", v->sn);
-	KS_C_SET(ec_level, "%s", v->ec);
-	KS_C_SET(id, "%s", v->id);
-	KS_C_SET(bus_type, "pci-express");
-	KS_C_SET(bus_width, "x%d lanes", p->width);
-	KS_C_SET(bus_speed, "%d", p->speed);
-	KS_U_SET(core_clock, v->cclk);
-	KS_U_SET(port_cnt, sc->params.nports);
-
-	pci_vendor = pci_config_get16(sc->pci_regh, PCI_CONF_VENID);
-	KS_C_SET(pci_vendor_id, "0x%x", pci_vendor);
-
-	pci_device = pci_config_get16(sc->pci_regh, PCI_CONF_DEVID);
-	KS_C_SET(pci_device_id, "0x%x", pci_device);
-
-	KS_C_SET(port_type, "%s/%s/%s/%s",
+	KS_SET_CHAR(kstatp, driver_version, DRV_VERSION);
+
+	const struct vpd_params *vpd = &sc->params.vpd;
+	KS_SET_STR(kstatp, serial_number, (const char *)vpd->sn);
+	KS_SET_STR(kstatp, ec_level, (const char *)vpd->ec);
+	KS_SET_STR(kstatp, id, (const char *)vpd->id);
+	KS_SET_U64(kstatp, core_clock, vpd->cclk);
+	KS_SET_U64(kstatp, port_cnt, sc->params.nports);
+
+	KS_SET_CHAR(kstatp, port_type, "%s/%s/%s/%s",
 	    t4_port_speed_name(sc->port[0]),
 	    t4_port_speed_name(sc->port[1]),
 	    t4_port_speed_name(sc->port[2]),
@@ -2192,8 +2710,28 @@ struct t4_wc_kstats {
 	kstat_named_t write_coal_success;
 	kstat_named_t write_coal_failure;
 };
+
+static int
+t4_update_wc_kstats(kstat_t *ksp, int rw)
+{
+	struct t4_wc_kstats *kstatp = (struct t4_wc_kstats *)ksp->ks_data;
+	struct adapter *sc = ksp->ks_private;
+
+	if (rw == KSTAT_WRITE)
+		return (0);
+
+	if (t4_cver_ge(sc, CHELSIO_T5)) {
+		const uint32_t wc_total = t4_read_reg(sc, A_SGE_STAT_TOTAL);
+		const uint32_t wc_failure = t4_read_reg(sc, A_SGE_STAT_MATCH);
+		KS_SET_U64(kstatp, write_coal_success, wc_total - wc_failure);
+		KS_SET_U64(kstatp, write_coal_failure, wc_failure);
+	}
+
+	return (0);
+}
+
 static kstat_t *
-setup_wc_kstats(struct adapter *sc)
+t4_setup_wc_kstats(struct adapter *sc)
 {
 	kstat_t *ksp;
 	struct t4_wc_kstats *kstatp;
@@ -2209,10 +2747,10 @@ setup_wc_kstats(struct adapter *sc)
 
 	kstatp = (struct t4_wc_kstats *)ksp->ks_data;
 
-	KS_UINIT(write_coal_success);
-	KS_UINIT(write_coal_failure);
+	KS_INIT_U64(kstatp, write_coal_success);
+	KS_INIT_U64(kstatp, write_coal_failure);
 
-	ksp->ks_update = update_wc_kstats;
+	ksp->ks_update = t4_update_wc_kstats;
 	/* Install the kstat */
 	ksp->ks_private = (void *)sc;
 	kstat_install(ksp);
